//
// RegConstraints.h defines constraints on allowable registry values.
//

#ifndef _REG_CONSTRAINTS_H
#define _REG_CONSTRAINTS_H

// String lengths

#define MAX_UPLOAD_URL_LIST_LENGTH              512
#define MAX_UPLOAD_URL_LENGTH                   256
#define MAX_SERVER_LENGTH                       128
#define MAX_REGISTRY_STRING_LENGTH              MAX_UPLOAD_URL_LIST_LENGTH

// The default minimum number of free MB required on disk in order
// to continue logging

#define MIN_FREE_SPACE                          5
#define DEFAULT_FREE_SPACE                      40
#define MAX_FREE_SPACE                          2000

// Minimum, default, and maximum log buffer sizes, in KB

#define MIN_LOG_BUFFER_SIZE                     256
#define DEFAULT_LOG_BUFFER_SIZE                 1024
#define MAX_LOG_BUFFER_SIZE                     4096

// Minimum, default, and maximum trace piece size limit, in MB

#define MIN_TRACE_PIECE_SIZE_LIMIT              10
#define DEFAULT_TRACE_PIECE_SIZE_LIMIT          100
#define MAX_TRACE_PIECE_SIZE_LIMIT              400

// Minimum, default, and maximum per-Web-session transfer size limit, in KB

#define MIN_TRANSFER_SIZE_LIMIT                 256
#define DEFAULT_TRANSFER_SIZE_LIMIT             2048
#define MAX_TRANSFER_SIZE_LIMIT                 102400

#define DEFAULT_PROXY_PORT                      0

#define DEFAULT_UPLOAD_URL_LIST \
           "http://ifrit.cs.berkeley.edu/~lorch/vtrace/upload-pc.cgi;" \
           "http://wyvern.cs.berkeley.edu/~lorch/vtrace/upload-sun.cgi;" \
           "http://golem.cs.berkeley.edu/~lorch/vtrace/upload.cgi;" \
           "http://djinn.cs.berkeley.edu/~lorch/vtrace/upload.cgi;" \
           "http://ananke.cs.berkeley.edu/~lorch/vtrace/upload-sun.cgi;" \
           "http://dybbuk.cs.berkeley.edu/~lorch/vtrace/upload-sun.cgi"

// Class GUID's for device classes we filter

#define KEYBOARD_CLASS_GUID "4D36E96B-E325-11CE-BFC1-08002BE10318"
#define STORAGE_VOLUME_CLASS_GUID "71A27CDD-812A-11D0-BEC7-08002BE2092F"

#endif
