//
// HookFuncs.h contains the function prototypes for the hook functions defined
// in HookFuncs.c.
//

BOOL
WINAPI
VTraceHookGetMessageA(
    LPMSG lpMsg,
    HWND hWnd ,
    UINT wMsgFilterMin,
    UINT wMsgFilterMax);

BOOL
WINAPI
VTraceHookGetMessageW(
    LPMSG lpMsg,
    HWND hWnd ,
    UINT wMsgFilterMin,
    UINT wMsgFilterMax);

BOOL
WINAPI
VTraceHookPeekMessageA(
    LPMSG lpMsg,
    HWND hWnd ,
    UINT wMsgFilterMin,
    UINT wMsgFilterMax,
    UINT wRemoveMsg);

BOOL
WINAPI
VTraceHookPeekMessageW(
    LPMSG lpMsg,
    HWND hWnd ,
    UINT wMsgFilterMin,
    UINT wMsgFilterMax,
    UINT wRemoveMsg);

DWORD
WINAPI
VTraceHookMsgWaitForMultipleObjects(
    DWORD nCount,
    LPHANDLE pHandles,
    BOOL fWaitAll,
    DWORD dwMilliseconds,
    DWORD dwWakeMask);

DWORD
WINAPI
VTraceHookMsgWaitForMultipleObjectsEx(
    DWORD nCount,
    LPHANDLE pHandles,
    DWORD dwMilliseconds,
    DWORD dwWakeMask,
    DWORD dwFlags);

BOOL
WINAPI
VTraceHookWaitMessage(
    VOID);

BOOL
WINAPI
VTraceHookGetInputState(
    VOID);

DWORD
WINAPI
VTraceHookGetQueueStatus(
    UINT flags);

LONG
WINAPI
VTraceHookDispatchMessageA(
    CONST MSG *lpMsg);

LONG
WINAPI
VTraceHookDispatchMessageW(
    CONST MSG *lpMsg);

int
WINAPI
VTraceHookTranslateAccelerator(
    HWND hWnd,
    HACCEL hAccTable,
    LPMSG lpMsg);

int
WINAPI
VTraceHookTranslateAcceleratorA(
    HWND hWnd,
    HACCEL hAccTable,
    LPMSG lpMsg);

int
WINAPI
VTraceHookTranslateAcceleratorW(
    HWND hWnd,
    HACCEL hAccTable,
    LPMSG lpMsg);

BOOL
WINAPI
VTraceHookTranslateMessage(
    CONST MSG *lpMsg);

BOOL
WINAPI
VTraceHookTranslateMDISysAccel(
    HWND hWndClient,
    LPMSG lpMsg);

LRESULT
WINAPI
VTraceHookSendMessageA(
    HWND hWnd,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam);

LRESULT
WINAPI
VTraceHookSendMessageW(
    HWND hWnd,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam);

LRESULT
WINAPI
VTraceHookSendMessageTimeoutA(
    HWND hWnd,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam,
    UINT fuFlags,
    UINT uTimeout,
    LPDWORD lpdwResult);

LRESULT
WINAPI
VTraceHookSendMessageTimeoutW(
    HWND hWnd,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam,
    UINT fuFlags,
    UINT uTimeout,
    LPDWORD lpdwResult);

BOOL
WINAPI
VTraceHookSendMessageCallbackA(
    HWND hWnd,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam,
    SENDASYNCPROC lpResultCallBack,
    DWORD dwData);

BOOL
WINAPI
VTraceHookSendMessageCallbackW(
    HWND hWnd,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam,
    SENDASYNCPROC lpResultCallBack,
    DWORD dwData);

BOOL
WINAPI
VTraceHookPostMessageA(
    HWND hWnd,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam);

BOOL
WINAPI
VTraceHookPostMessageW(
    HWND hWnd,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam);

BOOL
WINAPI
VTraceHookPostThreadMessageA(
    DWORD idThread,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam);

BOOL
WINAPI
VTraceHookPostThreadMessageW(
    DWORD idThread,
    UINT Msg,
    WPARAM wParam,
    LPARAM lParam);

UINT
WINAPI
VTraceHookSetTimer( 
    HWND hWnd, 
    UINT nIDEvent, 
    UINT uElapse, 
    TIMERPROC lpTimerFunc 
    );

BOOL
WINAPI
VTraceHookKillTimer( 
    HWND hWnd, 
    UINT uIDEvent 
    ); 

HCURSOR
WINAPI
VTraceHookLoadCursorA(
    HINSTANCE hInstance,
    LPCSTR lpCursorName);

HCURSOR
WINAPI
VTraceHookLoadCursorW(
    HINSTANCE hInstance,
    LPCWSTR lpCursorName);

HCURSOR
WINAPI
VTraceHookLoadCursorFromFileA(
    LPCSTR    lpFileName);

HCURSOR
WINAPI
VTraceHookLoadCursorFromFileW(
    LPCWSTR    lpFileName);

HCURSOR
WINAPI
VTraceHookSetCursor(
    HCURSOR hCursor);

HWND
WINAPI
VTraceHookCreateWindowExA(
    DWORD dwExStyle,
    LPCSTR lpClassName,
    LPCSTR lpWindowName,
    DWORD dwStyle,
    int X,
    int Y,
    int nWidth,
    int nHeight,
    HWND hWndParent,
    HMENU hMenu,
    HINSTANCE hInstance,
    LPVOID lpParam);

HWND
WINAPI
VTraceHookCreateWindowExW(
    DWORD dwExStyle,
    LPCWSTR lpClassName,
    LPCWSTR lpWindowName,
    DWORD dwStyle,
    int X,
    int Y,
    int nWidth,
    int nHeight,
    HWND hWndParent,
    HMENU hMenu,
    HINSTANCE hInstance,
    LPVOID lpParam);

HWND
WINAPI
VTraceHookCreateDialogParamA(
    HINSTANCE hInstance,
    LPCSTR lpTemplateName,
    HWND hWndParent ,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam);

HWND
WINAPI
VTraceHookCreateDialogParamW(
    HINSTANCE hInstance,
    LPCWSTR lpTemplateName,
    HWND hWndParent ,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam);

HWND
WINAPI
VTraceHookCreateDialogIndirectParamA(
    HINSTANCE hInstance,
    LPCDLGTEMPLATEA lpTemplate,
    HWND hWndParent,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam);

HWND
WINAPI
VTraceHookCreateDialogIndirectParamW(
    HINSTANCE hInstance,
    LPCDLGTEMPLATEW lpTemplate,
    HWND hWndParent,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam);

HWND
WINAPI
VTraceHookCreateDialogIndirectParamAorW(
    HINSTANCE hInstance,
    LPCDLGTEMPLATE lpTemplate,
    HWND hWndParent,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam,
    DWORD unknownParameter);

int
WINAPI
VTraceHookDialogBoxParamA(
    HINSTANCE hInstance,
    LPCSTR lpTemplateName,
    HWND hWndParent,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam);

int
WINAPI
VTraceHookDialogBoxParamW(
    HINSTANCE hInstance,
    LPCWSTR lpTemplateName,
    HWND hWndParent,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam);

int
WINAPI
VTraceHookDialogBoxIndirectParamA(
    HINSTANCE hInstance,
    LPCDLGTEMPLATEA hDialogTemplate,
    HWND hWndParent,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam);

int
WINAPI
VTraceHookDialogBoxIndirectParamW(
    HINSTANCE hInstance,
    LPCDLGTEMPLATEW hDialogTemplate,
    HWND hWndParent,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam);

int
WINAPI
VTraceHookDialogBoxIndirectParamAorW(
    HINSTANCE hInstance,
    LPCDLGTEMPLATEA hDialogTemplate,
    HWND hWndParent,
    DLGPROC lpDialogFunc,
    LPARAM dwInitParam,
    DWORD unknownParameter);

HMODULE
WINAPI
VTraceHookLoadLibraryA(
    LPCSTR lpLibFileName);

HMODULE
WINAPI
VTraceHookLoadLibraryW(
    LPCWSTR lpLibFileName);

HMODULE
WINAPI
VTraceHookLoadLibraryExA(
    LPCSTR lpLibFileName,
    HANDLE hFile,
    DWORD dwFlags
    );

HMODULE
WINAPI
VTraceHookLoadLibraryExW(
    LPCWSTR lpLibFileName,
    HANDLE hFile,
    DWORD dwFlags
    );

BOOL
WINAPI
VTraceHookSetEvent(
    HANDLE hEvent
    );

BOOL
WINAPI
VTraceHookSetWaitableTimer( 
    HANDLE hTimer, 
    const LARGE_INTEGER *pDueTime, 
    LONG lPeriod, 
    PTIMERAPCROUTINE pfnCompletionRoutine, 
    LPVOID lpArgToCompletionRoutine, 
    BOOL fResume 
    );

BOOL
WINAPI
VTraceHookCancelWaitableTimer(
    HANDLE hTimer
    );

BOOL
WINAPI
VTraceHookReleaseSemaphore(
    HANDLE hSemaphore, 
    LONG lReleaseCount, 
    LPLONG lpPreviousCount 
);

BOOL
WINAPI
VTraceHookReleaseMutex(
    HANDLE hMutex
    );

BOOL
WINAPI
VTraceHookSignalObjectAndWait(
    HANDLE hObjectToSignal, 
    HANDLE hObjectToWaitOn, 
    DWORD dwMilliseconds, 
    BOOL bAlertable 
    );

DWORD
WINAPI
VTraceHookWaitForSingleObject(
    HANDLE hHandle,
    DWORD dwMilliseconds
    );

DWORD
WINAPI
VTraceHookWaitForSingleObjectEx(
    HANDLE hHandle,
    DWORD dwMilliseconds,
    BOOL bAlertable
    );

DWORD
WINAPI
VTraceHookWaitForMultipleObjects( 
    DWORD nCount, 
    CONST HANDLE *lpHandles, 
    BOOL bWaitAll, 
    DWORD dwMilliseconds 
    );

DWORD
WINAPI
VTraceHookWaitForMultipleObjectsEx( 
    DWORD nCount, 
    CONST HANDLE *lpHandles, 
    BOOL bWaitAll, 
    DWORD dwMilliseconds,
    BOOL bAlertable
    );
