//
// Handlers.h
//
// Exports from Handlers.c
//

////////////////////////////////////////////////////////////////////////////
//                         FUNCTION PROTOTYPES
////////////////////////////////////////////////////////////////////////////

NTSTATUS VTrcNetClientEventConnect (IN PVOID TdiEventContext,
                                    IN LONG RemoteAddressLength,
                                    IN PVOID RemoteAddress,
                                    IN LONG UserDataLength,
                                    IN PVOID UserData,
                                    IN LONG OptionsLength,
                                    IN PVOID Options,
                                    OUT CONNECTION_CONTEXT *ConnectionContext,
                                    OUT PIRP *AcceptIrp);

NTSTATUS VTrcNetClientEventDisconnect (IN PVOID TdiEventContext,
                                       IN CONNECTION_CONTEXT ConnectionContext,
                                       IN LONG DisconnectDataLength,
                                       IN PVOID DisconnectData,
                                       IN LONG DisconnectInformationLength,
                                       IN PVOID DisconnectInformation,
                                       IN ULONG DisconnectFlags);

NTSTATUS VTrcNetClientEventReceive (IN PVOID TdiEventContext,
                                    IN CONNECTION_CONTEXT ConnectionContext,
                                    IN ULONG ReceiveFlags,
                                    IN ULONG BytesIndicated,
                                    IN ULONG BytesAvailable,
                                    OUT ULONG *BytesTaken,
                                    IN PVOID Tsdu,
                                    OUT PIRP *IoRequestPacket);

NTSTATUS VTrcNetClientEventReceiveDatagram (IN PVOID TdiEventContext,
                                            IN LONG SourceAddressLength,
                                            IN PVOID SourceAddress,
                                            IN LONG OptionsLength,
                                            IN PVOID Options,
                                            IN ULONG ReceiveDatagramFlags,
                                            IN ULONG BytesIndicated,
                                            IN ULONG BytesAvailable,
                                            OUT ULONG *BytesTaken,
                                            IN PVOID Tsdu,
                                            OUT PIRP *IoRequestPacket);

NTSTATUS VTrcNetClientEventReceiveExpedited
  (IN PVOID TdiEventContext, IN CONNECTION_CONTEXT ConnectionContext,
   IN ULONG ReceiveFlags, IN ULONG BytesIndicated, IN ULONG BytesAvailable,
   OUT ULONG *BytesTaken, IN PVOID Tsdu, OUT PIRP *IoRequestPacket);

NTSTATUS
VTrcNetClientEventChainedReceive (
    IN PVOID TdiEventContext,
    IN CONNECTION_CONTEXT ConnectionContext,
    IN ULONG ReceiveFlags,
    IN ULONG ReceiveLength,        // length of client data in TSDU
    IN ULONG StartingOffset,       // offset of start of client data in TSDU
    IN PMDL  Tsdu,                 // TSDU data chain
    IN PVOID TsduDescriptor        // for call to TdiReturnChainedReceives
    );

NTSTATUS
VTrcNetClientEventChainedReceiveDatagram (
    IN PVOID TdiEventContext,       // the event context
    IN LONG SourceAddressLength,    // length of the originator of the datagram
    IN PVOID SourceAddress,         // string describing the originator of the
                                    // datagram
    IN LONG OptionsLength,          // options for the receive
    IN PVOID Options,               //
    IN ULONG ReceiveDatagramFlags,  //
    IN ULONG ReceiveDatagramLength, // length of client data in TSDU
    IN ULONG StartingOffset,        // offset of start of client data in TSDU
    IN PMDL  Tsdu,                  // TSDU data chain
    IN PVOID TsduDescriptor         // for call to TdiReturnChainedReceives
    );

NTSTATUS
VTrcNetClientEventChainedReceiveExpedited (
    IN PVOID TdiEventContext,
    IN CONNECTION_CONTEXT ConnectionContext,
    IN ULONG ReceiveFlags,
    IN ULONG ReceiveLength,      // length of client data in TSDU
    IN ULONG StartingOffset,     // offset of start of client data in TSDU
    IN PMDL  Tsdu,               // TSDU data chain
    IN PVOID TsduDescriptor      // for call to TdiReturnChainedReceives
    );
