//
// Structs.h contains definitions of useful structures
//

#include "../Common/RegConstraints.h"

///////////////////////////////////////////////////////////////////////////
//                                TYPES
///////////////////////////////////////////////////////////////////////////

// Below are my error codes

typedef enum { MY_ERROR_NONE,       // Operation successful
               MY_ERROR_TOTAL,      // Error requiring program to stop
               MY_ERROR_SERVER,     // Problem with current server
               MY_ERROR_FILE }      // Problem with current file
  MY_ERROR;

// A REGISTRY_INFO structure contains data gleaned from the registry.

typedef struct _registry_info {
  char mainDirectory[MAX_PATH];
  char uploadUrlList[MAX_UPLOAD_URL_LIST_LENGTH];
  char proxyServer[MAX_SERVER_LENGTH];
  DWORD proxyPort;
  DWORD maxTransferSize;
  DWORD userNumber;
  DWORD vtraceVersion;
  BOOL automaticUpload;
  DWORD freeBytesNeeded;
  DWORD maxTracePieceBytes;
} REGISTRY_INFO;

// A SERVER_INFO structure contains information about the current server
// being used for uploading.

typedef struct _server_info {
  char currentServer[MAX_SERVER_LENGTH];
  DWORD currentPort;
  char currentPartialUrl[MAX_UPLOAD_URL_LENGTH];
                                   // what goes in the "POST" command
  int currentUrlListIndex;         // where this server is in the URL list
  int urlListSize;                 // how big the URL list is
  int numUrlsFailedConsecutively;  // how many URL's in the list failed
} SERVER_INFO;

// A FILE_INFO structure contains information about the current file
// being operated on.

typedef struct _file_info {
  char fileNameHere[MAX_PATH];     // local file name
  char fileNameThere[MAX_PATH];    // remote file name
  DWORD remoteFileSize;            // length of remote file
  DWORD fileSize;                  // what the remote file size should be
  HANDLE fileHandle;               // open file handle
} FILE_INFO;
